using System;
using System.Runtime.InteropServices;

namespace Creaturelibbattling.Generated
{
    internal static class BattleStatCalculator
    {
        /// <returns>const BattleStatCalculator *</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_BattleStatCalculator_Construct")]
        internal static extern IntPtr Construct();

        /// <param name="p">const BattleStatCalculator *</param>
        /// <returns>void</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_BattleStatCalculator_Destruct")]
        internal static extern void Destruct(IntPtr p);

        /// <param name="out">unsigned int&</param>
        /// <param name="p">const BattleStatCalculator *</param>
        /// <param name="creature">Creature *</param>
        /// <param name="stat">Statistic</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_BattleStatCalculator_CalculateFlatStat")]
        internal static extern byte CalculateFlatStat(ref uint @out, IntPtr p, IntPtr creature, Statistic stat);

        /// <param name="out">unsigned int&</param>
        /// <param name="p">const BattleStatCalculator *</param>
        /// <param name="creature">Creature *</param>
        /// <param name="stat">Statistic</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_BattleStatCalculator_CalculateBoostedStat")]
        internal static extern byte CalculateBoostedStat(ref uint @out, IntPtr p, IntPtr creature, Statistic stat);

    }
}
