using System;
using System.Runtime.InteropServices;

namespace Creaturelibbattling.Generated
{
    internal static class ExecutingAttack
    {
        /// <param name="out">ExecutingAttack *&</param>
        /// <param name="targets">const Creature * *</param>
        /// <param name="targetCount">long unsigned int</param>
        /// <param name="numberHits">unsigned char</param>
        /// <param name="user">Creature *</param>
        /// <param name="attack">LearnedAttack *</param>
        /// <param name="script">Script *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_ExecutingAttack_Construct")]
        internal static extern byte Construct(ref IntPtr @out, IntPtr targets, ulong targetCount, byte numberHits, IntPtr user, IntPtr attack, IntPtr script);

        /// <param name="p">ExecutingAttack *</param>
        /// <returns>void</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_ExecutingAttack_Destruct")]
        internal static extern void Destruct(IntPtr p);

        /// <param name="out">HitData *&</param>
        /// <param name="p">ExecutingAttack *</param>
        /// <param name="target">Creature *</param>
        /// <param name="hit">unsigned char</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_ExecutingAttack_GetHitData")]
        internal static extern byte GetHitData(ref IntPtr @out, IntPtr p, IntPtr target, byte hit);

        /// <param name="p">ExecutingAttack *</param>
        /// <param name="target">Creature *</param>
        /// <returns>bool</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_ExecutingAttack_IsCreatureTarget")]
        internal static extern bool IsCreatureTarget(IntPtr p, IntPtr target);

        /// <param name="p">ExecutingAttack *</param>
        /// <returns>Creature *</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_ExecutingAttack_GetUser")]
        internal static extern IntPtr GetUser(IntPtr p);

        /// <param name="p">ExecutingAttack *</param>
        /// <returns>LearnedAttack *</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_ExecutingAttack_GetAttack")]
        internal static extern IntPtr GetAttack(IntPtr p);

    }
}
