using System;
using System.Runtime.InteropServices;

namespace Creaturelibbattling.Generated
{
    internal static class ExperienceLibrary
    {
        /// <returns>const ExperienceLibrary *</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_ExperienceLibrary_Construct")]
        internal static extern IntPtr Construct();

        /// <param name="p">const ExperienceLibrary *</param>
        /// <returns>void</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_ExperienceLibrary_Destruct")]
        internal static extern void Destruct(IntPtr p);

        /// <param name="p">const ExperienceLibrary *</param>
        /// <param name="faintedMon">Creature *</param>
        /// <param name="opponents">Creature * *</param>
        /// <param name="opponentsCount">long unsigned int</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibBattling", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_ExperienceLibrary_HandleExperienceGain")]
        internal static extern byte HandleExperienceGain(IntPtr p, IntPtr faintedMon, IntPtr opponents, ulong opponentsCount);

    }
}
