using System;
using System.Runtime.InteropServices;

namespace Creatureliblibrary.Generated
{
    internal static class LibrarySettings
    {
        /// <param name="maximalLevel">unsigned char</param>
        /// <param name="maximalMoves">unsigned char</param>
        /// <returns>const LibrarySettings *</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_LibrarySettings_Construct")]
        internal static extern IntPtr Construct(byte maximalLevel, byte maximalMoves);

        /// <param name="p">const LibrarySettings *</param>
        /// <returns>void</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_LibrarySettings_Destruct")]
        internal static extern void Destruct(IntPtr p);

        /// <param name="p">const LibrarySettings *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_LibrarySettings_GetMaximalLevel")]
        internal static extern byte GetMaximalLevel(IntPtr p);

        /// <param name="p">const LibrarySettings *</param>
        /// <returns>unsigned char</returns>
        [DllImport("CreatureLibLibrary", CallingConvention = CallingConvention.Cdecl, EntryPoint= "CreatureLib_LibrarySettings_GetMaximalMoves")]
        internal static extern byte GetMaximalMoves(IntPtr p);

    }
}
