using System;
using System.Runtime.InteropServices;
using Pkmnlib.Generated;
using PkmnLibSharp.Utilities;

namespace PkmnLibSharp.Library
{
    public class Species : PointerWrapper
    {
        // ReSharper disable once SuggestBaseTypeForParameter
        public Species(ushort id, string name, Forme defaultForme, float genderRatio, string growthRate,
            byte captureRate,
            byte baseHappiness) : base(PokemonSpecies.Construct(id, name.ToPtr(), defaultForme.Ptr, genderRatio,
            growthRate.ToPtr(), captureRate, baseHappiness))
        {
        }

        internal override void DeletePtr()
        {
            Pokemon.Destruct(Ptr);
        }
    }
}